public class BSync {

   private static void printUsage() {
     System.out.println("Usage: java BSync #threads #round");
     System.out.println("  use -1 for unbounded #rounds");
     System.exit(0);
   }

   public static void main(String[] args) {
     if (args.length != 2) {
       printUsage();
     }
     int[] intArgs = new int[args.length];
     for (int i = 0; i < args.length; i++)
       try {
         intArgs[i] = Integer.parseInt(args[i]);
       } catch (NumberFormatException e) {
         System.out.println("Invalid argument #" + i + 1);
         printUsage();
       }

     int n = intArgs[0];
     int nRounds = intArgs[1];
     Barrier barrier = new TurnBarrier(n);
     Thread[] threads = new Thread[n];
     for (int i = 0; i < n; i++) {
       Barrierito b = new Barrierito(i, barrier, nRounds);
       Thread t = new Thread(b);
       threads[i] = t;
     }
     for (Thread t: threads)
       t.start();
     try {
       for (Thread t: threads)
         t.join();
     } catch (InterruptedException e) {
         System.out.println("Interrupted!");
     }
   }
}
