import java.util.Random;

public class Barrierito implements Runnable {

  public void run() {
     int round = 0;
     while (round < nRounds || nRounds < 0) {
       try {
         // sleep up to one second
         Thread.sleep(rng.nextInt(1000));
         barrier.await();
       } catch (InterruptedException e) {
         System.out.println("Thread " + id + " interrupted.");
       }
       System.out.println("Thread " + id + " has passed the barrier!");
       if (nRounds > 0)
         round++;
     }
  }

  Barrierito(int id, Barrier barrier, int nRounds) {
    this.id = id;
    this.barrier = barrier;
    this.nRounds = nRounds;
  }

  private final int id;
  private final Barrier barrier;
  private final int nRounds;

  private static final Random rng = new Random();
}

